--- arch/arm/special/empeg_input.c	Thu Nov  1 22:15:47 2001
+++ arch/arm/special/empeg_input.c.irtrans2.0b3.with.toggle	Thu Nov  1 22:11:49 2001
@@ -188,14 +188,24 @@
 #endif
 };
 
+/*
+IR Translation Code:  Original by Frank Van Gestel, with modifications by Tony Cebzanov
+*/
 #if USE_IRTRANS
 struct trans_entry {
 	input_code old;			/* code to translate */
 	input_code new;			/* code to replace old code */
+	input_code mod;			/* code to replace old code if modifier is active */	
 	unsigned int down;		/* is button down? */
 	struct trans_entry *next;	/* next entry */
 };
 
+int irtrans_mod = 0;
+int irtrans_mod_down = 0;
+static int irtrans_modifier = 0xAD520C;
+extern void mybeep(int pitch, int duration, int volume);
+
+
 static struct trans_entry *trans_list;
 static int write_codes=0;
 #endif
@@ -934,28 +944,52 @@
 		if ( write_codes )
 			printk("%X -> ",data);
 		te=trans_list;
-		while ( ( te != NULL ) && ( ! foundte ) )
-			{
-			if ( data == (te->old | 0x80000000) )
-				{
-				if (te->down)
-					{
+		if ( data == irtrans_modifier ) {
+			if (irtrans_mod_down == 0) {
+				printk("mod down\n");
+    			irtrans_mod_down = 1;
+    			irtrans_mod = !irtrans_mod;
+    			if (irtrans_mod == 0) {
+        			mybeep (54, 50, 50);
+        		} else {
+					mybeep (66, 50, 50);
+				}
+	
+			}
+		}
+		else if (data == (irtrans_modifier | 0x80000000) ) {
+			printk("mod up\n");
+			irtrans_mod_down = 0;
+		}
+		while ( ( te != NULL ) && ( ! foundte ) ) {
+			if ( data == (te->old | 0x80000000) ) {
+				if (te->down) {
 					te->down=0;
-					data = (te->new | 0x80000000);
+					if ( irtrans_mod ) {
+						data = (te->mod | 0x80000000);					
+					} else {
+						data = (te->new | 0x80000000);
 					}
-				foundte=1;
-				}
+					foundte=1;
+					}
+			}
 			if ( te->old == data )
-				{
-				if (! te->down)
+			{
+					if (! te->down)
 					{
-					te->down=1;
-					data = te->new;
-					} else send_code=0;
-				foundte=1;
+						te->down=1;
+						if ( irtrans_mod ) {
+							data = te->mod;
+						} else {
+							data = te->new;
+						}
+					} else {
+						send_code=0;
+					}
+					foundte=1;
 				}
-			te=te->next;
-			}
+				te=te->next;
+		}
 		if ( ! send_code )
 			{
 			if ( write_codes )
@@ -1138,24 +1172,32 @@
 			{
 			input_code old=0;
 			input_code new=0;
+			input_code mod=0;
 			s=(char *)strtok(NULL,":");
 			if ( s != NULL )
 				old=simple_strtol(s,NULL,0);
 			else
 				file_read=1;
-			s=(char *)strtok(NULL,"\n");
+			s=(char *)strtok(NULL,":");
 			if ( s != NULL )
 				new=simple_strtol(s,NULL,0);
 			else
 				file_read=1;
+			s=(char *)strtok(NULL,"\n");
+			if ( s != NULL )
+				mod=simple_strtol(s,NULL,0);
+			else
+				file_read=1;
 			if ( ! file_read )
 				{
 				prevte=te;
 				te = (struct trans_entry *)kmalloc(sizeof(struct trans_entry),GFP_KERNEL);
 				te->old=old;
 				te->new=new;
+				te->mod=mod;
 				te->down=0;
-				printk("%X->%X %d->%d\n",old,new,old,new);
+				//printk("%X->%X %d->%d\n",old,new,old,new);
+				printk("%X: [%X | %X]\n",old,new,mod);
 				te->next=NULL;
 				if ( trans_list == NULL ) {
 					trans_list = te;
--- arch/arm/special/empeg_audio3.c	Thu Nov  1 22:20:51 2001
+++ arch/arm/special/empeg_audio3.c.withmybeep	Thu Nov  1 22:23:13 2001
@@ -183,6 +183,7 @@
 static void empeg_audio_beep_end_sched(void *unused);
 static void empeg_audio_interrupt(int irq, void *dev_id, struct pt_regs *regs);
 static void empeg_audio_emit_action(void *);
+extern void mybeep (int pitch, int duration, int volume);
 #ifdef	CONFIG_PROC_FS
 static int empeg_audio_read_proc(char *buf, char **start, off_t offset,
 				 int length, int *eof, void *private);
@@ -440,6 +441,11 @@
 	/* invalid command */
 	return -EINVAL;
 }
+
+void mybeep (int pitch, int duration, int volume) {
+	empeg_audio_beep ( &audio[0], pitch, duration, volume);
+}
+
 
 static void empeg_audio_beep(audio_dev *dev, int pitch, int length, int volume)
 {
